Package org.apache.tapestry5

## Class SymbolConstants

- java.lang.Object
- - org.apache.tapestry5.SymbolConstants

-     public class SymbolConstants
      extends java.lang.Object

  Defines the names of symbols used to configure Tapestry.
  See Also:
    `SymbolSource`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `AJAX_FORM_LOOP_ADD_ROW_LINK_CSS_CLASS` | Defines the CSS class that will be given to the add row link generated by AjaxFormLoop.
    `static java.lang.String` | `APPLICATION_CATALOG` | The location of the application-wide component messages catalog, relative to the web application context.
    `static java.lang.String` | `APPLICATION_FOLDER` | The name of a folder in which the Tapestry application executes.
    `static java.lang.String` | `APPLICATION_VERSION` | Version number of the application.
    `static java.lang.String` | `ASSET_PATH_PREFIX` | Prefix to be used for all resource paths, used to recognize which requests are for assets.
    `static java.lang.String` | `ASSET_URL_FULL_QUALIFIED` | Boolean value to indicate if every `Asset` should be fully qualified or not.
    `static java.lang.String` | `BEAN_DISPLAY_CSS_CLASS` | Defines the CSS class that will be given to the <dl> HTML element generated by BeanDisplay.
    `static java.lang.String` | `BEAN_EDITOR_BOOLEAN_PROPERTY_DIV_CSS_CLASS` | Defines the CSS class that will be given to the <div> HTML element generated by BeanEditor/BeanEditForm for boolean properties.
    `static java.lang.String` | `BOOTSTRAP_ROOT` | The root asset path for Twitter Bootstrap; if your application uses a modified version of Bootstrap, you can override this symbol to have Tapestry automatically use your version.
    `static java.lang.String` | `CHARSET` | The charset used when rendering page markup; the charset is also used as the request encoding when handling incoming requests.
    `static java.lang.String` | `CLUSTERED_SESSIONS` | If "true" then at the end of each request the `SessionPersistedObjectAnalyzer` will be called on each session persisted object that was accessed during the request.
    `static java.lang.String` | `COMBINE_SCRIPTS` | If "true" then JavaScript files in a `JavaScriptStack` will be combined into a single virtual JavaScript file.
    `static java.lang.String` | `COMPACT_JSON` | If "true", then JSON page initialization content is compressed; if "false" then extra white space is added (pretty printing).
    `static java.lang.String` | `COMPONENT_DEPENDENCY_FILE` | Defines what file should be used to store and read component dependency information.
    `static java.lang.String` | `COMPONENT_RENDER_TRACING_ENABLED` | If "true" and `TapestryHttpSymbolConstants.PRODUCTION_MODE` is off, comments will be rendered before and after the rendering of any component allowing more visibility into which components rendered which markup.
    `static java.lang.String` | `COMPRESS_WHITESPACE` | Controls whether whitespace is compressed by default in templates, or left as is.
    `static java.lang.String` | `CONTEXT_PATH` | Identifies the context path of the application, as determined from `ServletContext.getContextPath()`.
    `static java.lang.String` | `COOKIE_MAX_AGE` | The default time interval that cookies created by Tapestry will be kept in the client web browser.
    `static java.lang.String` | `CORS_ALLOW_CREDENTIALS` | Boolean value defining whether the Access-Control-Allow-Credentials HTTP header should be set automatically in the response for CORS requests.
    `static java.lang.String` | `CORS_ALLOW_METHODS` | Value to be used in the Access-Control-Allow-Methods in CORS preflight request responses.
    `static java.lang.String` | `CORS_ALLOWED_HEADERS` | Value to be used in the Access-Control-Allow-Headers in CORS preflight request responses.
    `static java.lang.String` | `CORS_ALLOWED_ORIGINS` | Comma-delimited of origins allowed for CORS.
    `static java.lang.String` | `CORS_ENABLED` | Defines whether the CORS (Cross-Origing Resource Sharing) support should be enabled or not.
    `static java.lang.String` | `CORS_EXPOSE_HEADERS` | Value to be used in the Access-Control-Expose-Headers in CORS request responses.
    `static java.lang.String` | `CORS_MAX_AGE` | Value to be used in the Access-Control-Max-Age in responses to preflight CORS requests.
    `static java.lang.String` | `DATEPICKER` | The Asset path to the embedded datepicker.
    `static java.lang.String` | `DEFAULT_STYLESHEET` | The default stylesheet automatically inserted into every rendered HTML page when no Bootstrap version is enabled (i.e both `Trait.BOOTSTRAP_3` and `Trait.BOOTSTRAP_4` traits are disabled, something done by NoBootstrapModule).
    `static java.lang.String` | `ENABLE_HTML5_SUPPORT` | Defines whether HTML5 features should be used.
    `static java.lang.String` | `ENABLE_PAGELOADING_MASK` | If true, then when a page includes any JavaScript, a `script` block is added to insert a pageloader mask into the page; the pageloader mask ensure that the user can't interact with the page until after the page is fully initialized.
    `static java.lang.String` | `ENCODE_LOCALE_INTO_PATH` | If "true" (the default), then the `PersistentLocale` will be encoded into the `Link` path by the `ComponentEventLinkEncoder` service.
    `static java.lang.String` | `ERROR_CSS_CLASS` | Defines the CSS class that will be given to the HTML element generated by Error.
    `static java.lang.String` | `ERRORS_BASE_CSS_CLASS` | Defines the prefix of the CSS class that will be given to the outer <div> element generated by Errors.
    `static java.lang.String` | `ERRORS_CLOSE_BUTTON_CSS_CLASS` | Defines the CSS class that will be given to the close <button> generated by Errors.
    `static java.lang.String` | `ERRORS_DEFAULT_CLASS_PARAMETER_VALUE` | Defines the default value of the Errors's `class` parameter.
    `static java.lang.String` | `EXCEPTION_REPORT_PAGE` | Name of page used to report exceptions; the page must implement `ExceptionReporter`.
    `static java.lang.String` | `EXCEPTION_REPORTS_DIR` | The directory to which exception report files should be written.
    `static java.lang.String` | `EXECUTION_MODE` | A comma separated list of execution modes used to control how the application is initialized.
    `static java.lang.String` | `FILE_CHECK_INTERVAL` | Time interval defining how often Tapestry will check for updates to local files (including classes).
    `static java.lang.String` | `FILE_CHECK_UPDATE_TIMEOUT` | Time interval that sets how long Tapestry will wait to obtain the exclusive lock needed to check local files.
    `static java.lang.String` | `FONT_AWESOME_ROOT` | The root asset path for Font Awesome; if your application uses a modified version of it, you can override this symbol to have Tapestry automatically use your version.
    `static java.lang.String` | `FORM_CLIENT_LOGIC_ENABLED` | Used as the default for the Form's autofocus and clientValidation parameters.
    `static java.lang.String` | `FORM_FIELD_CSS_CLASS` | Defines the CSS class that will be given to form field components which are AbstractField subclasses.
    `static java.lang.String` | `FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_CSS_CLASS` | Defines the CSS class of the HTML element generated by the FormGroup mixin and the BeanEditForm and BeanEditor.
    `static java.lang.String` | `FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_NAME` | Defines the name of the HTML element that will surround the HTML form field generated by the FormGroup mixin and the BeanEditForm and BeanEditor.
    `static java.lang.String` | `FORM_GROUP_LABEL_CSS_CLASS` | Defines the CSS class that will be given to <label> element generated by the FormGroup mixin and the BeanEditForm and BeanEditor components.
    `static java.lang.String` | `FORM_GROUP_WRAPPER_CSS_CLASS` | Defines the CSS class that will be given to HTML element (usually a div) <div> generated by the FormGroup mixin and the BeanEditForm and BeanEditor components surrounding the label and the field.
    `static java.lang.String` | `GZIP_COMPRESSION_ENABLED` | If "true" (the default) then GZip compression is enabled for dynamic requests and for static assets.
    `static java.lang.String` | `HMAC_PASSPHRASE` | A passphrase used as the basis of hash-based message authentication (HMAC) for any object stream data stored on the client.
    `static java.lang.String` | `HOSTNAME` | The hostname that application should use when constructing an absolute URL.
    `static java.lang.String` | `HOSTPORT` | The hostport that application should use when constructing an absolute URL.
    `static java.lang.String` | `HOSTPORT_SECURE` | The secure (https) hostport that application should use when constructing an absolute URL.
    `static java.lang.String` | `INCLUDE_CORE_STACK` | If true (the default), then Tapestry will automatically include the "core" stack in all pages.
    `static java.lang.String` | `JAVASCRIPT_INFRASTRUCTURE_PROVIDER` | Tapestry relies on an underlying client-side JavaScript infrastructure framework to handle DOM manipulation, event handling, and Ajax requests.
    `static java.lang.String` | `LENIENT_DATE_FORMAT` | Defines whether `DateFormat` instances created by Tapestry should be lenient or not by default.
    `static java.lang.String` | `MIN_GZIP_SIZE` | Minimum output stream size, in bytes, before output is compressed using GZIP.
    `static java.lang.String` | `MINIFICATION_ENABLED` | If "true", then resources (individually or when aggregated into stacks) will be minimized via the `ResourceMinimizer` service.
    `static java.lang.String` | `MODULE_PATH_PREFIX` | Prefix used for all module resources.
    `static java.lang.String` | `MULTIPLE_CLASSLOADERS` | Defines whether multiple classloaders will be used instead of one for smarter page invalidation.
    `static java.lang.String` | `OMIT_EXPIRATION_CACHE_CONTROL_HEADER` | When an asset (typically, a JavaScript module) is streamed without an explicit expiration header, then this value is sent as the `Cache-Control` header; the default is "max-age=60, must-revalidate".
    `static java.lang.String` | `OMIT_GENERATOR_META` | Used to omit the normal Tapestry framework generator meta tag.
    `static java.lang.String` | `OPENAPI_APPLICATION_VERSION` | Defines the version of this application in the generated OpenAPI description (i.e.
    `static java.lang.String` | `OPENAPI_BASE_PATH` | Defines a base path to the generated OpenAPI description relative to the application URL as defined by `BaseURLSource.getBaseURL(boolean)`.
    `static java.lang.String` | `OPENAPI_DESCRIPTION` | Defines the description of this application in the generated OpenAPI description.
    `static java.lang.String` | `OPENAPI_DESCRIPTION_PATH` | Defines the path the OpenAPI description file of this application's REST endpoints will be published.
    `static java.lang.String` | `OPENAPI_TITLE` | Defines the title of this application in the generated OpenAPI description.
    `static java.lang.String` | `OPENAPI_VERSION` | Defines the OpenAPI version to be used in the generated OpenAPI description.
    `static java.lang.String` | `PERSISTENCE_STRATEGY` | Identifies the default persistence strategy for all pages that do not provide an override (using this value as `key`).
    `static java.lang.String` | `PRELOADER_MODE` | Controls in what environment page preloading should occur.
    `static java.lang.String` | `PRODUCTION_MODE` | Indicates whether Tapestry is running in production mode or developer mode.
    `static java.lang.String` | `PRODUCTION_MODE_VALUE` | A version of `TapestryHttpSymbolConstants.PRODUCTION_MODE` as a symbol reference.
    `static java.lang.String` | `PUBLISH_OPENAPI_DEFINITON` | Defines whether the OpenAPI description file of this application's REST endpoints should be published or not.
    `static java.lang.String` | `RESTRICTIVE_ENVIRONMENT` | A general switch for restrictive environments, such as Google App Engine, which forbid some useful operations, such as creating files or directories.
    `static java.lang.String` | `SCRIPTACULOUS` | The Asset path to the embedded copy of script.aculo.us packaged with Tapestry.
    `static java.lang.String` | `SECURE_ENABLED` | If "true" (which itself defaults to production mode), then the `Secure` annotation will be honored.
    `static java.lang.String` | `SESSION_LOCKING_ENABLED` | If true (the default), then Tapestry will apply locking semantics around access to the `HttpSession`.
    `static java.lang.String` | `START_PAGE_NAME` | The logical name of the start page, the page that is rendered for the root URL.
    `static java.lang.String` | `STRICT_CSS_URL_REWRITING` | Defines whether `CSSURLRewriter` will throw an exception when a CSS file references an URL which doesn't exist.
    `static java.lang.String` | `SUPPORTED_LOCALES` | The list of locales supported by the application; locales identified in the incoming request are "narrowed" to one of these values.
    `static java.lang.String` | `TAPESTRY_VERSION` | The version number of the core Tapestry framework, or UNKNOWN if the version number is not available (which should only occur when developing Tapestry).

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SymbolConstants()` |

  - ### Method Summary

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### EXECUTION_MODE

          public static final java.lang.String EXECUTION_MODE

      A comma separated list of execution modes used to control how the application is initialized. Each modes can contribute a list (comma separated) of Module classes to be loaded during startup, the order in which they appear is preserved. The default value is: `production`. This is an alias for `TapestryHttpSymbolConstants.EXECUTION_MODE`.
      See Also:
        Constant Field Values

    - #### PRODUCTION_MODE

          public static final java.lang.String PRODUCTION_MODE

      Indicates whether Tapestry is running in production mode or developer mode. This affects a large number of Tapestry behaviors related to performance and security, including how exceptions are reported, whether far-future expire headers are emitted, whether JavaScript files may be combined, whether JSON is compressed, whether component field and parameter values are shadowed to instance variables (to assist with debugging), and more. This is an alias to `TapestryHttpSymbolConstants.PRODUCTION_MODE`.
      See Also:
        Constant Field Values

    - #### PRODUCTION_MODE_VALUE

          public static final java.lang.String PRODUCTION_MODE_VALUE

      A version of `TapestryHttpSymbolConstants.PRODUCTION_MODE` as a symbol reference. This can be used as the default value of other symbols, to indicate that their default matches whatever PRODUCTION_MODE is set to, which is quite common.
      Since:
        5.2.0

    - #### SUPPORTED_LOCALES

          public static final java.lang.String SUPPORTED_LOCALES

      The list of locales supported by the application; locales identified in the incoming request are "narrowed" to one of these values. The first locale name in the list is the default locale used when no proper match can be found.
      See Also:
        Constant Field Values

    - #### COMPRESS_WHITESPACE

          public static final java.lang.String COMPRESS_WHITESPACE

      Controls whether whitespace is compressed by default in templates, or left as is. The factory default is to compress whitespace. (This can also be overridden using the xml:space attribute inside template elements.)
      See Also:
        Constant Field Values

    - #### FILE_CHECK_INTERVAL

          public static final java.lang.String FILE_CHECK_INTERVAL

      Time interval defining how often Tapestry will check for updates to local files (including classes). Starting with 5.3, this is only used when not running in production mode. The default is "1 s" (one second), which is appropriate for development. With Tapestry 5.2 and earlier this number should be raised in a production environment.
      See Also:
        Constant Field Values

    - #### FILE_CHECK_UPDATE_TIMEOUT

          public static final java.lang.String FILE_CHECK_UPDATE_TIMEOUT

      Time interval that sets how long Tapestry will wait to obtain the exclusive lock needed to check local files. The default is "50 ms". Starting with 5.3, this is only used when not running in production mode.
      See Also:
        Constant Field Values

    - #### TAPESTRY_VERSION

          public static final java.lang.String TAPESTRY_VERSION

      The version number of the core Tapestry framework, or UNKNOWN if the version number is not available (which should only occur when developing Tapestry). This is an alias for `TapestryHttpSymbolConstants.TAPESTRY_VERSION`.
      See Also:
        Constant Field Values

    - #### APPLICATION_CATALOG

          public static final java.lang.String APPLICATION_CATALOG

      The location of the application-wide component messages catalog, relative to the web application context. This will normally be `WEB-INF/app.properties`.
      See Also:
        Constant Field Values

    - #### CHARSET

          public static final java.lang.String CHARSET

      The charset used when rendering page markup; the charset is also used as the request encoding when handling incoming requests. The default is "UTF-8". This is an alias for `TapestryHttpSymbolConstants.CHARSET`.
      See Also:
        Constant Field Values

    - #### FORM_CLIENT_LOGIC_ENABLED

          public static final java.lang.String FORM_CLIENT_LOGIC_ENABLED

      Used as the default for the Form's autofocus and clientValidation parameters. If overridden to "false", then Forms will not (unless explicitly specified) use client validation or autofocus, which in turn, means that most pages with Forms will not make use of the Tapestry JavaScript stack.
      See Also:
        Constant Field Values

    - #### EXCEPTION_REPORT_PAGE

          public static final java.lang.String EXCEPTION_REPORT_PAGE

      Name of page used to report exceptions; the page must implement `ExceptionReporter`. This is used by the default exception report handler service.
      See Also:
        Constant Field Values

    - #### PERSISTENCE_STRATEGY

          public static final java.lang.String PERSISTENCE_STRATEGY

      Identifies the default persistence strategy for all pages that do not provide an override (using this value as `key`).
      Since:
        5.1.0.0
      See Also:
        Constant Field Values

    - #### MIN_GZIP_SIZE

          public static final java.lang.String MIN_GZIP_SIZE

      Minimum output stream size, in bytes, before output is compressed using GZIP. Shorter streams are not compressed. Tapestry buffers this amount and switches to a GZIP output stream as needed. The default is "100". This is an alias to `TapestryHttpSymbolConstants.MIN_GZIP_SIZE`.
      Since:
        5.1.0.0
      See Also:
        `TapestryHttpSymbolConstants.GZIP_COMPRESSION_ENABLED`, Constant Field Values

    - #### APPLICATION_VERSION

          public static final java.lang.String APPLICATION_VERSION

      Version number of the application. Prior to 5.4, this version number was integrated into asset URLs. Starting with 5.4, a checksum of the individual asset's content is used instead, and this version number is only used for documentation purposes; it appears in the default exception report page, for example. The default value is "0.0.1". In 5.3 and earlier, the default value was a random hexadecimal string. This is an alias to `TapestryHttpSymbolConstants.APPLICATION_VERSION`.
      Since:
        5.1.0.0
      See Also:
        `AssetDispatcher`, `AssetPathConstructor`, Constant Field Values

    - #### OMIT_GENERATOR_META

          public static final java.lang.String OMIT_GENERATOR_META

      Used to omit the normal Tapestry framework generator meta tag. The meta tag is rendered by default, but clients who do not wish to advertise their use of Tapestry may set this symbol to "true".
      Since:
        5.1.0.0
      See Also:
        Constant Field Values

    - #### GZIP_COMPRESSION_ENABLED

          public static final java.lang.String GZIP_COMPRESSION_ENABLED

      If "true" (the default) then GZip compression is enabled for dynamic requests and for static assets. If you are using a server that handles GZip compression for you, or you don't want to use the extra processing power necessary to GZIP requests, then override this to "false". This is an alias to `TapestryHttpSymbolConstants.GZIP_COMPRESSION_ENABLED`.
      Since:
        5.1.0.0
      See Also:
        `TapestryHttpSymbolConstants.MIN_GZIP_SIZE`, `ResponseCompressionAnalyzer`, `CompressionAnalyzer`, Constant Field Values

    - #### SECURE_ENABLED

          public static final java.lang.String SECURE_ENABLED

      If "true" (which itself defaults to production mode), then the `Secure` annotation will be honored. If "false" (i.e., development mode), then the annotation and related HTTP/HTTPS logic is ignored.
      Since:
        5.1.0.1
      See Also:
        Constant Field Values

    - #### ENCODE_LOCALE_INTO_PATH

          public static final java.lang.String ENCODE_LOCALE_INTO_PATH

      If "true" (the default), then the `PersistentLocale` will be encoded into the `Link` path by the `ComponentEventLinkEncoder` service. If overridden to "false" this does not occur, but you should provide a `LinkCreationListener2` (registered with the `LinkCreationHub`) in order to add the locale as a query parameter (or provide some alternate means of persisting the locale between requests).
      Since:
        5.1.0.1
      See Also:
        Constant Field Values

    - #### COMBINE_SCRIPTS

          public static final java.lang.String COMBINE_SCRIPTS

      If "true" then JavaScript files in a `JavaScriptStack` will be combined into a single virtual JavaScript file. Defaults to "true" in production mode.
      Since:
        5.1.0.2
      See Also:
        Constant Field Values

    - #### COOKIE_MAX_AGE

          public static final java.lang.String COOKIE_MAX_AGE

      The default time interval that cookies created by Tapestry will be kept in the client web browser. The default is "7 d" (that is, seven days).
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### START_PAGE_NAME

          public static final java.lang.String START_PAGE_NAME

      The logical name of the start page, the page that is rendered for the root URL.
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### DEFAULT_STYLESHEET

          public static final java.lang.String DEFAULT_STYLESHEET

      The default stylesheet automatically inserted into every rendered HTML page when no Bootstrap version is enabled (i.e both `Trait.BOOTSTRAP_3` and `Trait.BOOTSTRAP_4` traits are disabled, something done by NoBootstrapModule). It was deprecated in 5.4 with no replacement (the stylesheet is now associated with the core `JavaScriptStack`.), but undeprecated in 5.5.0 with the caveat described above.
      Since:
        5.2.0
      See Also:
        `NoBootstrapModule`, Constant Field Values

    - #### SCRIPTACULOUS

          public static final java.lang.String SCRIPTACULOUS

      The Asset path to the embedded copy of script.aculo.us packaged with Tapestry.
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### DATEPICKER

          public static final java.lang.String DATEPICKER

      The Asset path to the embedded datepicker.
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### COMPACT_JSON

          public static final java.lang.String COMPACT_JSON

      If "true", then JSON page initialization content is compressed; if "false" then extra white space is added (pretty printing). Defaults to "true" in production mode.
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### COMPONENT_RENDER_TRACING_ENABLED

          public static final java.lang.String COMPONENT_RENDER_TRACING_ENABLED

      If "true" and `TapestryHttpSymbolConstants.PRODUCTION_MODE` is off, comments will be rendered before and after the rendering of any component allowing more visibility into which components rendered which markup. Defaults to "false". Component render tracing may be enabled per-request by the presence of a request parameter "t:component-trace" with a value of "true".
      Since:
        5.2.5
      See Also:
        Constant Field Values

    - #### HOSTNAME

          public static final java.lang.String HOSTNAME

      The hostname that application should use when constructing an absolute URL. The default is "", i.e. an empty string, in which case system will use request.getServerName(). Not the same as environment variable HOSTNAME, but you can also contribute "$HOSTNAME" as the value to make it the same as the environment variable HOSTNAME. This is an alias to `TapestryHttpSymbolConstants.HOSTNAME`.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### HOSTPORT

          public static final java.lang.String HOSTPORT

      The hostport that application should use when constructing an absolute URL. The default is "0", i.e. use the port value from the request. This is an alias to `TapestryHttpSymbolConstants.HOSTPORT`.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### HOSTPORT_SECURE

          public static final java.lang.String HOSTPORT_SECURE

      The secure (https) hostport that application should use when constructing an absolute URL. The default is "0", i.e. use the value from the request. This is an alias to `TapestryHttpSymbolConstants.HOSTPORT_SECURE`.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### MINIFICATION_ENABLED

          public static final java.lang.String MINIFICATION_ENABLED

      If "true", then resources (individually or when aggregated into stacks) will be minimized via the `ResourceMinimizer` service. If "false", then minification is disabled. Tracks production mode (minification is normally disabled in development mode). Note that Tapestry's default implementation of `ResourceMinimizer` does nothing; minification is provided by add-on libraries.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### CLUSTERED_SESSIONS

          public static final java.lang.String CLUSTERED_SESSIONS

      If "true" then at the end of each request the `SessionPersistedObjectAnalyzer` will be called on each session persisted object that was accessed during the request. This is provided as a performance enhancement for servers that do not use clustered sessions. The default is `true`, to preserve 5.2 behavior. For non-clustered applications (the majority), this value should be overridden to `false`. A future release of Tapestry may change the default. This is an alias to `TapestryHttpSymbolConstants.CLUSTERED_SESSIONS`.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### APPLICATION_FOLDER

          public static final java.lang.String APPLICATION_FOLDER

      The name of a folder in which the Tapestry application executes. Prior to 5.3, a Tapestry application always responded to all URLs in the context under the context root; by setting this to the name of a folder, the T5 URLs will be inside that folder only, and should match a corresponding entry in the `web.xml` configuration file. This is useful when running multiple servlets within the same web application (such as when migrating from Tapestry 4 or some other framework, to Tapestry 5). Effectively, if this symbol is set to a value, that folder name will be placed after the context path (typically "/") and before the locale, page name, or other prefix. For example, if this symbol is set to "app", the `web.xml <url-pattern>` should be set to `/app/*`, and Tapestry will only be in invoked by the servlet container for requests inside the virtual `app` folder. This also affects the search for page templates (which are allowed within the web context). When set to a non-blank value, page templates are searched for in the folder, rather than in the root context. The default value is the empty string, which preserves Tapestry 5.2 behavior (and continues to be appropriate for most applications). Note that while Tapestry is case-insensitive, the servlet container is not, so the configured value must exactly match the folder name inside the `<url-parameter>` value, including case.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### ASSET_URL_FULL_QUALIFIED

          public static final java.lang.String ASSET_URL_FULL_QUALIFIED

      Boolean value to indicate if every `Asset` should be fully qualified or not. Default to `false` meaning no Asset URL will be fully qualified.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### ASSET_PATH_PREFIX

          public static final java.lang.String ASSET_PATH_PREFIX

      Prefix to be used for all resource paths, used to recognize which requests are for assets. This value is appended to the context path and the (optional application folder. It may contain slashes, but should not begin or end with one. The default is "assets".
      See Also:
        Constant Field Values

    - #### MODULE_PATH_PREFIX

          public static final java.lang.String MODULE_PATH_PREFIX

      Prefix used for all module resources. This may contain slashes, but should not being or end with one. Tapestry will create two `Dispatcher`s from this: one for normal modules, the other for GZip compressed modules (by appending ".gz" to this value). The default is "modules".
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### CONTEXT_PATH

          public static final java.lang.String CONTEXT_PATH

      Identifies the context path of the application, as determined from `ServletContext.getContextPath()`. This is either a blank string or a string that starts with a slash but does not end with one. This is an alias to `TapestryHttpSymbolConstants.CONTEXT_PATH`.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### HMAC_PASSPHRASE

          public static final java.lang.String HMAC_PASSPHRASE

      A passphrase used as the basis of hash-based message authentication (HMAC) for any object stream data stored on the client. The default phrase is the empty string, which will result in a logged runtime error. You should configure this to a reasonable value (longer is better) and ensure that all servers in your cluster share the same value (configuring this in code, rather than the command line, is preferred).
      Since:
        5.3.6
      See Also:
        `ClientDataEncoder`, Constant Field Values

    - #### BOOTSTRAP_ROOT

          public static final java.lang.String BOOTSTRAP_ROOT

      The root asset path for Twitter Bootstrap; if your application uses a modified version of Bootstrap, you can override this symbol to have Tapestry automatically use your version. The value should be a path to a folder (under "classpath:" or "context:") and should not include a trailing slash.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### FONT_AWESOME_ROOT

          public static final java.lang.String FONT_AWESOME_ROOT

      The root asset path for Font Awesome; if your application uses a modified version of it, you can override this symbol to have Tapestry automatically use your version. The value should be a path to a folder (under "classpath:" or "context:") and should not include a trailing slash.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### JAVASCRIPT_INFRASTRUCTURE_PROVIDER

          public static final java.lang.String JAVASCRIPT_INFRASTRUCTURE_PROVIDER

      Tapestry relies on an underlying client-side JavaScript infrastructure framework to handle DOM manipulation, event handling, and Ajax requests. Through Tapestry 5.3, the foundation was Prototype. In 5.4, support for jQuery has been added, and it is possible to add others. This symbol defines a value that is used to select a resource that is provided to the `ModuleManager` service as a `JavaScriptModuleConfiguration` to provide a specific implementation of the `t5/core/dom` module. Tapestry 5.4 directly supports "prototype" or "jquery". To support other foundation frameworks, override this symbol value and supply your own module configuration. In Tapestry 5.4, this defaults to "prototype" for compatibility with 5.3. This will likely change in 5.5 to default to "jquery". At some point in the future, Prototype support will no longer be present.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### SESSION_LOCKING_ENABLED

          public static final java.lang.String SESSION_LOCKING_ENABLED

      If true (the default), then Tapestry will apply locking semantics around access to the `HttpSession`. Reading attribute names occurs with a shared read lock; getting or setting an attribute upgrades to an exclusive write lock. This can tend to serialize threads when a number of simultaneous (Ajax) requests from the client arrive ... however, many implementations of HttpSession are not thread safe, and often mutable objects are stored in the session and shared between threads. Leaving this on the default will yield a more robust application; setting it to false may speed up processing for more Ajax intensive applications (but care should then be given to ensuring that objects shared inside the session are themselves immutable or thread-safe). This is an alias to `TapestryHttpSymbolConstants.SESSION_LOCKING_ENABLED`.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### INCLUDE_CORE_STACK

          public static final java.lang.String INCLUDE_CORE_STACK

      If true (the default), then Tapestry will automatically include the "core" stack in all pages.
      Since:
        5.4
      See Also:
        TAP5-2169, Constant Field Values

    - #### FORM_GROUP_WRAPPER_CSS_CLASS

          public static final java.lang.String FORM_GROUP_WRAPPER_CSS_CLASS

      Defines the CSS class that will be given to HTML element (usually a div) <div> generated by the FormGroup mixin and the BeanEditForm and BeanEditor components surrounding the label and the field. If the value isn't `form-group`, the div will have `class="form-group [value]`. The default value is `form-group`.
      Since:
        5.4
      See Also:
        TAP5-2182, Constant Field Values

    - #### FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_NAME

          public static final java.lang.String FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_NAME

      Defines the name of the HTML element that will surround the HTML form field generated by the FormGroup mixin and the BeanEditForm and BeanEditor. If this symbol is null or an empty string, no element will be generated surrouding the form field. The default value is the empty string (no wrapping).
      Since:
        5.4
      See Also:
        TAP5-2182, `FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_CSS_CLASS`, Constant Field Values

    - #### FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_CSS_CLASS

          public static final java.lang.String FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_CSS_CLASS

      Defines the CSS class of the HTML element generated by the FormGroup mixin and the BeanEditForm and BeanEditor. when FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_NAME is not set to null or the empty string. The default value is the empty string (no CSS class added).
      Since:
        5.4
      See Also:
        TAP5-2182, Constant Field Values

    - #### FORM_GROUP_LABEL_CSS_CLASS

          public static final java.lang.String FORM_GROUP_LABEL_CSS_CLASS

      Defines the CSS class that will be given to <label> element generated by the FormGroup mixin and the BeanEditForm and BeanEditor components. The default value is `control-label`.
      Since:
        5.4
      See Also:
        TAP5-2182, Constant Field Values

    - #### FORM_FIELD_CSS_CLASS

          public static final java.lang.String FORM_FIELD_CSS_CLASS

      Defines the CSS class that will be given to form field components which are AbstractField subclasses. The default value is `form-control`.
      Since:
        5.4
      See Also:
        TAP5-2182, Constant Field Values

    - #### BEAN_DISPLAY_CSS_CLASS

          public static final java.lang.String BEAN_DISPLAY_CSS_CLASS

      Defines the CSS class that will be given to the <dl> HTML element generated by BeanDisplay. The default value is `well dl-horizontal`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### BEAN_EDITOR_BOOLEAN_PROPERTY_DIV_CSS_CLASS

          public static final java.lang.String BEAN_EDITOR_BOOLEAN_PROPERTY_DIV_CSS_CLASS

      Defines the CSS class that will be given to the <div> HTML element generated by BeanEditor/BeanEditForm for boolean properties. The default value is `input-group`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### ERROR_CSS_CLASS

          public static final java.lang.String ERROR_CSS_CLASS

      Defines the CSS class that will be given to the HTML element generated by Error. If the value isn't `help-block`, the class attribute will be `help-block [symbol value]` The default value is `help-block`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### AJAX_FORM_LOOP_ADD_ROW_LINK_CSS_CLASS

          public static final java.lang.String AJAX_FORM_LOOP_ADD_ROW_LINK_CSS_CLASS

      Defines the CSS class that will be given to the add row link generated by AjaxFormLoop. The default value is `btn btn-default btn-sm`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### ERRORS_BASE_CSS_CLASS

          public static final java.lang.String ERRORS_BASE_CSS_CLASS

      Defines the prefix of the CSS class that will be given to the outer <div> element generated by Errors. The value of Errors's `class` parameter appended after the prefix and a space character. The default value is `alert-dismissable`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### ERRORS_DEFAULT_CLASS_PARAMETER_VALUE

          public static final java.lang.String ERRORS_DEFAULT_CLASS_PARAMETER_VALUE

      Defines the default value of the Errors's `class` parameter. The default value for this symbol is `alert alert-danger`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### ERRORS_CLOSE_BUTTON_CSS_CLASS

          public static final java.lang.String ERRORS_CLOSE_BUTTON_CSS_CLASS

      Defines the CSS class that will be given to the close <button> generated by Errors. The default value is `close`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### LENIENT_DATE_FORMAT

          public static final java.lang.String LENIENT_DATE_FORMAT

      Defines whether `DateFormat` instances created by Tapestry should be lenient or not by default. The default value is `false`.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### EXCEPTION_REPORTS_DIR

          public static final java.lang.String EXCEPTION_REPORTS_DIR

      The directory to which exception report files should be written. The default is appropriate for development: `build/exceptions`, and should be changed for production.
      Since:
        5.4
      See Also:
        `ExceptionReporter`, Constant Field Values

    - #### STRICT_CSS_URL_REWRITING

          public static final java.lang.String STRICT_CSS_URL_REWRITING

      Defines whether `CSSURLRewriter` will throw an exception when a CSS file references an URL which doesn't exist. The default value is `false`.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### OMIT_EXPIRATION_CACHE_CONTROL_HEADER

          public static final java.lang.String OMIT_EXPIRATION_CACHE_CONTROL_HEADER

      When an asset (typically, a JavaScript module) is streamed without an explicit expiration header, then this value is sent as the `Cache-Control` header; the default is "max-age=60, must-revalidate". Setting max-age to a value above zero significantly reduces the number of client requests for module content, as client browsers will then cache previously downloaded versions. For normal assets, which are immutable, and fingerprinted with a content hash, there is no need to set max age, and instead, a far-future expiration date is provided.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### ENABLE_HTML5_SUPPORT

          public static final java.lang.String ENABLE_HTML5_SUPPORT

      Defines whether HTML5 features should be used. Value used in the default implementation of `Html5Support.isHtml5SupportEnabled()`. Default value: `false`.
      Since:
        5.4
      See Also:
        `Html5Support.isHtml5SupportEnabled()`, Constant Field Values

    - #### RESTRICTIVE_ENVIRONMENT

          public static final java.lang.String RESTRICTIVE_ENVIRONMENT

      A general switch for restrictive environments, such as Google App Engine, which forbid some useful operations, such as creating files or directories. Defaults to false.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### ENABLE_PAGELOADING_MASK

          public static final java.lang.String ENABLE_PAGELOADING_MASK

      If true, then when a page includes any JavaScript, a `script` block is added to insert a pageloader mask into the page; the pageloader mask ensure that the user can't interact with the page until after the page is fully initialized.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### PRELOADER_MODE

          public static final java.lang.String PRELOADER_MODE

      Controls in what environment page preloading should occur. By default, preloading only occurs in production.
      Since:
        5.4
      See Also:
        `PagePreloader`, `PreloaderMode`, Constant Field Values

    - #### OPENAPI_VERSION

          public static final java.lang.String OPENAPI_VERSION

      Defines the OpenAPI version to be used in the generated OpenAPI description. Default value is `3.0.0`.
      Since:
        5.8.0
      See Also:
        `DefaultOpenApiDescriptionGenerator`, `OpenApiDescriptionGenerator`, Constant Field Values

    - #### OPENAPI_TITLE

          public static final java.lang.String OPENAPI_TITLE

      Defines the title of this application in the generated OpenAPI description. No default value is provided.
      Since:
        5.8.0
      See Also:
        `DefaultOpenApiDescriptionGenerator`, `OpenApiDescriptionGenerator`, Constant Field Values

    - #### OPENAPI_DESCRIPTION

          public static final java.lang.String OPENAPI_DESCRIPTION

      Defines the description of this application in the generated OpenAPI description. No default value is provided.
      Since:
        5.8.0
      See Also:
        `DefaultOpenApiDescriptionGenerator`, `OpenApiDescriptionGenerator`, Constant Field Values

    - #### OPENAPI_APPLICATION_VERSION

          public static final java.lang.String OPENAPI_APPLICATION_VERSION

      Defines the version of this application in the generated OpenAPI description (i.e. info/version). No default value is provided.
      Since:
        5.8.0
      See Also:
        `DefaultOpenApiDescriptionGenerator`, `OpenApiDescriptionGenerator`, Constant Field Values

    - #### PUBLISH_OPENAPI_DEFINITON

          public static final java.lang.String PUBLISH_OPENAPI_DEFINITON

      Defines whether the OpenAPI description file of this application's REST endpoints should be published or not. The default value is `false`.
      Since:
        5.8.0
      See Also:
        `OpenApiDescriptionGenerator`, `OPENAPI_DESCRIPTION_PATH`, Constant Field Values

    - #### OPENAPI_DESCRIPTION_PATH

          public static final java.lang.String OPENAPI_DESCRIPTION_PATH

      Defines the path the OpenAPI description file of this application's REST endpoints will be published. It should start with a slash. Default value is `/openapi.json`. The description will only be published if {`PUBLISH_OPENAPI_DEFINITON` is set to `true`.
      Since:
        5.8.0
      See Also:
        `OpenApiDescriptionGenerator`, Constant Field Values

    - #### OPENAPI_BASE_PATH

          public static final java.lang.String OPENAPI_BASE_PATH

      Defines a base path to the generated OpenAPI description relative to the application URL as defined by `BaseURLSource.getBaseURL(boolean)`. It should be either the empty string, meaning there's no base path, or a string starting and ending with a slash. Default value is "/" (without the quotes)
      Since:
        5.8.0
      See Also:
        `OpenApiDescriptionGenerator`, Constant Field Values

    - #### CORS_ENABLED

          public static final java.lang.String CORS_ENABLED

      Defines whether the CORS (Cross-Origing Resource Sharing) support should be enabled or not. Default value is "false". If you set this to "true", you should also set `CORS_ALLOWED_ORIGINS`. This is an alias for `TapestryHttpSymbolConstants.CORS_ENABLED`.
      Since:
        5.8.2
      See Also:
        `CorsHandler`, `CorsHttpServletRequestFilter`, Constant Field Values

    - #### CORS_ALLOWED_ORIGINS

          public static final java.lang.String CORS_ALLOWED_ORIGINS

      Comma-delimited of origins allowed for CORS. The special value "*" means allowing all origins. This is used by the default implementation of `CorsHandlerHelper.getAllowedOrigin(javax.servlet.http.HttpServletRequest)`. Default value is the empty string (i.e. no origins allowed and CORS actually disabled). This is an alias for `TapestryHttpSymbolConstants.CORS_ALLOWED_ORIGINS`.
      Since:
        5.8.2
      See Also:
        Constant Field Values

    - #### CORS_ALLOW_CREDENTIALS

          public static final java.lang.String CORS_ALLOW_CREDENTIALS

      Boolean value defining whether the Access-Control-Allow-Credentials HTTP header should be set automatically in the response for CORS requests. Default value is `false`. This is used by the default implementation of `CorsHandlerHelper.configureCredentials(javax.servlet.http.HttpServletResponse)`. This is an alias for `TapestryHttpSymbolConstants.CORS_ALLOW_CREDENTIALS`.
      Since:
        5.8.2
      See Also:
        Constant Field Values

    - #### CORS_ALLOW_METHODS

          public static final java.lang.String CORS_ALLOW_METHODS

      Value to be used in the Access-Control-Allow-Methods in CORS preflight request responses. This is used by the default implementation of `CorsHandlerHelper.configureMethods(javax.servlet.http.HttpServletResponse)`. Default value is `GET,HEAD,PUT,PATCH,POST,DELETE`. This is an alias for `TapestryHttpSymbolConstants.CORS_ALLOW_METHODS`.
      Since:
        5.8.2
      See Also:
        Constant Field Values

    - #### CORS_ALLOWED_HEADERS

          public static final java.lang.String CORS_ALLOWED_HEADERS

      Value to be used in the Access-Control-Allow-Headers in CORS preflight request responses. This is used by the default implementation of `CorsHandlerHelper.configureAllowedHeaders(javax.servlet.http.HttpServletResponse, javax.servlet.http.HttpServletRequest)`. Default value is the empty string. This is an alias for `TapestryHttpSymbolConstants.CORS_ALLOWED_HEADERS`.
      Since:
        5.8.2
      See Also:
        Constant Field Values

    - #### CORS_EXPOSE_HEADERS

          public static final java.lang.String CORS_EXPOSE_HEADERS

      Value to be used in the Access-Control-Expose-Headers in CORS request responses. This is used by the default implementation of `CorsHandlerHelper.configureExposeHeaders(javax.servlet.http.HttpServletResponse)`. Default value is the empty string. This is an alias for `TapestryHttpSymbolConstants.CORS_EXPOSE_HEADERS`.
      Since:
        5.8.2
      See Also:
        Constant Field Values

    - #### CORS_MAX_AGE

          public static final java.lang.String CORS_MAX_AGE

      Value to be used in the Access-Control-Max-Age in responses to preflight CORS requests. This is used by the default implementation of `CorsHandlerHelper.configureMaxAge(javax.servlet.http.HttpServletResponse)`. Default value is the empty string. This is an alias for `TapestryHttpSymbolConstants.CORS_MAX_AGE`.
      Since:
        5.8.2
      See Also:
        Constant Field Values

    - #### MULTIPLE_CLASSLOADERS

          public static final java.lang.String MULTIPLE_CLASSLOADERS

      Defines whether multiple classloaders will be used instead of one for smarter page invalidation. This is ignored when in production mode. Default value is `false`.
      Since:
        5.8.3
      See Also:
        `PageClassLoaderContextManager`, Constant Field Values

    - #### COMPONENT_DEPENDENCY_FILE

          public static final java.lang.String COMPONENT_DEPENDENCY_FILE

      Defines what file should be used to store and read component dependency information. It can be either an absolute path or a path relative to the current folder where the JVM is running.

      This symbol is ignored when in production mode.

      Default value is `tapestryComponentDependencies.json` (ComponentDependencyRegistry.FILENAME).

      Since:
        5.8.4
      See Also:
        `ComponentDependencyRegistry`, Constant Field Values

  - ### Constructor Detail

    - #### SymbolConstants

          public SymbolConstants()